diff -urN Original_4.4.4_r1/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/SurfaceProvider.java AndroidSource/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/SurfaceProvider.java
--- Original_4.4.4_r1/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/SurfaceProvider.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/SurfaceProvider/src/com/remote/surfaceprovider/SurfaceProvider.java	2016-09-27 17:43:56.629147730 +0900
@@ -0,0 +1,1203 @@
+
+package com.remote.surfaceprovider;
+
+import java.io.BufferedOutputStream;
+import java.io.BufferedReader;
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.io.OutputStream;
+import java.net.ServerSocket;
+import java.net.Socket;
+import java.net.UnknownHostException;
+import java.nio.ByteBuffer;
+
+import android.service.remote.IRemoteService;
+import android.service.remote.SdPackage;
+
+import com.example.surfaceprovider.R;
+
+import android.service.remote.vData;
+import android.app.Activity;
+import android.app.KeyguardManager;
+import android.content.Context;
+import android.content.Intent;
+import android.graphics.Bitmap;
+import android.media.AudioFormat;
+import android.media.AudioManager;
+import android.media.AudioTrack;
+import android.media.MediaCodec;
+import android.media.MediaCodecInfo;
+import android.media.MediaFormat;
+import android.media.MediaCodec.BufferInfo;
+import android.net.Uri;
+import android.os.AsyncTask;
+import android.os.Bundle;
+import android.os.Environment;
+import android.os.PowerManager;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.util.Log;
+import android.view.Menu;
+import android.view.MenuItem;
+import android.view.MotionEvent;
+import android.view.Surface;
+import android.view.SurfaceHolder;
+import android.view.SurfaceView;
+import android.view.View;
+import android.view.View.OnTouchListener;
+import android.view.ViewGroup.LayoutParams;
+import android.view.Window;
+import android.view.WindowManager;
+import android.widget.ImageView;
+
+public class SurfaceProvider extends Activity implements SurfaceHolder.Callback {
+    // private String serverIP = "192.168.0.26";
+    private String serverIP = "";
+    public int vport = 30000;
+    private String TAG = "SurfaceProvider";
+    SurfaceHolder mHolder;
+    SurfaceView surfaceView;
+    ImageView imageView;
+
+    public long aSync = 0, vSync = 0;
+    public String mode = "";
+
+    public class mVideoPlayerAsync extends AsyncTask<Object, Void, Void> {
+        private MediaFormat format;
+        private MediaCodec mDecoder;
+        private Surface surface;
+
+        @Override
+        protected Void doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+            Socket socket = new Socket();
+            try {
+                System.setProperty("http.keepAlive", "false");
+                // ServerSocket ss = new ServerSocket(vport);
+                // ss.setReuseAddress(true);
+                // try {
+                // Thread.sleep(4000);
+                // } catch (InterruptedException e2) {
+                // // TODO Auto-generated catch block
+                // e2.printStackTrace();
+                // }
+                Log.d(TAG, serverIP + "  " + vport);
+
+                int a = 0;
+                // socket = new Socket(serverIP, vport);
+                while (!socket.isConnected()) {
+                    try {
+                        socket = new Socket(serverIP, vport);
+                        socket.setTcpNoDelay(true);
+                        socket.setKeepAlive(true);
+                        Log.d(TAG, ++a + "");
+                        if (a > 2000)
+                            break;
+                    } catch (Exception e) {
+                        try {
+                            Thread.sleep(10);
+                        } catch (InterruptedException e1) {
+                            // TODO Auto-generated catch block
+                            e1.printStackTrace();
+                        }
+
+                    }
+                }
+
+                // socket.setTcpNoDelay(true);
+                // socket.setReceiveBufferSize(5*1024*1024);
+                // socket = new Socket(serverIP, vport);
+                while (true) {
+                    // Socket socket = ss.accept();
+                    Log.d(TAG, "Video Client is ready to go, " + socket.getRemoteSocketAddress());
+                    InputStream is = socket.getInputStream();
+                    ObjectInputStream ois = new ObjectInputStream(is);
+
+                    // just a test
+                    String mime = ois.readUTF();
+                    int width, height;
+                    Log.d(TAG, "Server: " + mime + "ed"); // "Server: connected"
+                                                          // should be printed
+
+                    // get format data
+                    vData vdata = (vData) ois.readObject();
+                    mime = vdata.getMime();
+                    width = vdata.getWidth();
+                    height = vdata.getHeight();
+                    format = MediaFormat.createVideoFormat(mime, width, height);
+                    format.setByteBuffer("csd-0",
+                            ByteBuffer.wrap(vdata.get_csd0()));
+                    format.setByteBuffer("csd-1",
+                            ByteBuffer.wrap(vdata.get_csd1()));
+
+                    // hard coding for test
+                    // byte[] header_sps = { 0, 0, 0, 1, 0x67, 0x42, 0x0, 0x28,
+                    // 0xffffffe9, 0x1, 0x68, 0x7b, 0x20 };
+                    // byte[] header_pps = { 0, 0, 0, 1, 0x68, 0xffffffce, 0x1,
+                    // 0xe, 0x20 };
+                    // format.setByteBuffer("csd-0",
+                    // ByteBuffer.wrap(header_sps));
+                    // format.setByteBuffer("csd-1",
+                    // ByteBuffer.wrap(header_pps));
+                    // format.setInteger(MediaFormat.KEY_MAX_INPUT_SIZE, 47380);
+                    // format.setInteger(MediaFormat.KEY_DURATION, 5284377);
+                    Log.d(TAG, "server:  " + format.toString());
+
+                    // aspect..?
+                    // setSurfaceSize(width, height);
+
+                    // codec config and start
+                    mDecoder = MediaCodec.createDecoderByType(mime);
+                    mDecoder.configure(format, mHolder.getSurface(), null, 0);
+                    mDecoder.start();
+
+                    Log.d(TAG, "Video: server format setting done");
+
+                    // decoder start
+                    ByteBuffer[] inputBuffers = mDecoder.getInputBuffers();
+                    ByteBuffer[] outputBuffers = mDecoder.getOutputBuffers();
+                    BufferInfo info = new BufferInfo();
+                    boolean isEOS = false;
+                    long startMs = System.currentTimeMillis();
+
+                    while (!isEOS) {
+
+                        int inputIndex = 0;
+                        try {
+                            inputIndex = mDecoder.dequeueInputBuffer(-1);
+                        } catch (Exception e) {
+                            break;
+                        }
+                        if (inputIndex >= 0) {
+
+                            ByteBuffer buffer = inputBuffers[inputIndex];
+
+                            vdata = (vData) ois.readObject();
+                            int sampleSize = vdata.getSampleSize();
+                            buffer.clear();
+                            buffer.put(vdata.getSampleData());
+                            // int sampleSize = ois.readInt();
+                            byte[] tmp = null;
+                            if (sampleSize <= 0) {
+                                Log.d(TAG, "sampleSize is negative");
+                                continue;
+                            } else {
+                                tmp = new byte[sampleSize];
+                            }
+
+                            // Log.d(TAG, "got this much: " + tmp.length);
+
+                            long presentationTime = vdata.getPresentationTime();
+
+                            if (sampleSize < 0) {
+                                // We shouldn't stop the playback at this point,
+                                // just pass the EOS
+                                // flag to decoder, we will get it again from
+                                // the dequeueOutputBuffer
+                                Log.d("DecodeActivity",
+                                        "InputBuffer BUFFER_FLAG_END_OF_STREAM");
+                                mDecoder.queueInputBuffer(inputIndex, 0, 0, 0,
+                                        MediaCodec.BUFFER_FLAG_END_OF_STREAM);
+                                isEOS = true;
+                            }
+                            else {
+                                try {
+                                    mDecoder.queueInputBuffer(inputIndex, 0, sampleSize,
+                                            presentationTime, 0);
+                                    // mDecoder.queueInputBuffer(inputIndex, 0,
+                                    // sampleSize, vdata.getPresentationTime(),
+                                    // 0);
+                                    // mExtractor.advance();
+
+                                    // Log.d(TAG, "got this much: " +
+                                    // tmp.length);
+                                } catch (Exception e) {
+                                    break;
+                                }
+                            }
+                        }
+
+                        int outIndex = mDecoder
+                                .dequeueOutputBuffer(info, 4000);
+                        switch (outIndex) {
+                            case MediaCodec.INFO_OUTPUT_BUFFERS_CHANGED:
+                                Log.d(TAG, "INFO_OUTPUT_BUFFERS_CHANGED");
+                                outputBuffers = mDecoder.getOutputBuffers();
+                                break;
+                            case MediaCodec.INFO_OUTPUT_FORMAT_CHANGED:
+                                Log.d(TAG, "New format " + mDecoder.getOutputFormat());
+                                Log.d("VideoLatency", "VideoLatency ");
+                                Log.d("VideoLatency", "VideoLatency ");
+                                break;
+                            case MediaCodec.INFO_TRY_AGAIN_LATER:
+                                Log.d(TAG, "dequeueOutputBuffer timed out!");
+                                break;
+                            default:
+                                ByteBuffer buffer = outputBuffers[outIndex];
+                                // Log.v(TAG,
+                                // "We can't use this buffer but render it due to the API limit, "
+                                // + buffer);
+
+                                // We use a very simple clock to keep the video
+                                // FPS,
+                                // or the video playback will be too fast
+//                                vSync = info.presentationTimeUs;
+                                while (info.presentationTimeUs / 1000 > System
+                                        .currentTimeMillis() - startMs) {
+                                    try {
+                                        Thread.sleep(10);
+                                    } catch (InterruptedException e) {
+                                        e.printStackTrace();
+                                        break;
+                                    }
+                                }
+                                
+                                
+                                
+                                try {
+                                    mDecoder.releaseOutputBuffer(outIndex, true);
+                                } catch (Exception e) {
+                                    ;
+                                }
+                                break;
+                        }
+                        // All decoded frames have been rendered, we can stop
+                        // playing now
+                        if ((info.flags & MediaCodec.BUFFER_FLAG_END_OF_STREAM) != 0) {
+                            Log.d(TAG, "OutputBuffer BUFFER_FLAG_END_OF_STREAM");
+                            break;
+                        }
+                    }
+
+                    mDecoder.stop();
+                    mDecoder.release();
+                    socket.close();
+                }
+
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            } catch (ClassNotFoundException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+            return null;
+        }
+
+    }
+
+    public class mAudioPlayerAsync extends AsyncTask<Object, Void, Void> {
+
+        @Override
+        protected Void doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+            // variables of format
+            String mime = "";
+            int sampleRate = 0, channels = 0, bitrate = 0;
+            long duration = 0;
+            MediaFormat format = null;
+
+            InputStream in = null;
+            ObjectInputStream ois = null;
+            OutputStream out = null;
+            ObjectOutputStream oos = null;
+            Socket socket = new Socket();
+
+            try {
+                int aport = vport + 1;
+                System.setProperty("http.keepAlive", "false");
+                Log.d(TAG, "audio" + serverIP + "  " + aport);
+
+                int a = 0;
+                // socket = new Socket(serverIP, vport);
+                while (!socket.isConnected()) {
+                    try {
+                        socket = new Socket(serverIP, aport);
+                        socket.setTcpNoDelay(true);
+                        socket.setKeepAlive(true);
+                        Log.d(TAG, ++a + "");
+                        if (a > 500)
+                            break;
+                    } catch (Exception e) {
+                        try {
+                            Thread.sleep(10);
+                        } catch (InterruptedException e1) {
+                            // TODO Auto-generated catch block
+                            e1.printStackTrace();
+                        }
+
+                    }
+                }
+
+                // socket.setTcpNoDelay(true);
+                // ServerSocket aServer = new ServerSocket(aport);
+                // Socket socket = aServer.accept();
+                Log.d(TAG, "Audio Client is ready to go, " + socket.getRemoteSocketAddress());
+                out = socket.getOutputStream();
+                oos = new ObjectOutputStream(out);
+                in = socket.getInputStream();
+                ois = new ObjectInputStream(in);
+
+                String test = ois.readUTF();
+                if (test.equalsIgnoreCase("hello")) {
+                    Log.d(TAG, "client and server is all clear");
+                }
+
+                // getting meta-information for format from server (from here)
+                SdPackage format_package = (SdPackage) ois.readObject();
+                mime = format_package.getMime();
+                sampleRate = format_package.getSampleRate();
+                channels = format_package.getChannels();
+                duration = format_package.getDuration();
+                bitrate = format_package.getBitrate();
+                format = MediaFormat.createAudioFormat(mime, sampleRate,
+                        channels);
+
+                format.setInteger(MediaFormat.KEY_AAC_PROFILE,
+                        MediaCodecInfo.CodecProfileLevel.AACObjectLC);
+                format.setByteBuffer("csd-0",
+                        ByteBuffer.wrap(format_package.get_csd0()));
+                format.setLong(MediaFormat.KEY_DURATION, duration);
+                format.setInteger(MediaFormat.KEY_BIT_RATE, bitrate);
+                // getting variables from server is finished
+
+                // checking if everything is okay
+                Log.d(TAG, "Audio Track info: mime:" + mime + " sampleRate:"
+                        + sampleRate + " channels:" + channels + " bitrate:"
+                        + bitrate + " duration:" + duration);
+                Log.d(TAG, "Audio Track: " + format.toString());
+                // codec setting
+                MediaCodec codec;
+                codec = MediaCodec.createDecoderByType(mime);
+                codec.configure(format, null, null, 0);
+                codec.start();
+
+                ByteBuffer[] codecInputBuffers = codec.getInputBuffers();
+                ByteBuffer[] codecOutputBuffers = codec.getOutputBuffers();
+
+                int channelConfiguration = 0;
+                if (channels == 1) {
+                    channelConfiguration = AudioFormat.CHANNEL_OUT_MONO;
+                } else {
+                    channelConfiguration = AudioFormat.CHANNEL_OUT_STEREO;
+                }
+
+                // audiotrack object
+                int minSize = AudioTrack.getMinBufferSize(sampleRate,
+                        channelConfiguration, AudioFormat.ENCODING_PCM_16BIT);
+                AudioTrack audioTrack;
+                audioTrack = new AudioTrack(AudioManager.STREAM_MUSIC,
+                        sampleRate, channelConfiguration,
+                        AudioFormat.ENCODING_PCM_16BIT, minSize,
+                        AudioTrack.MODE_STREAM);
+                // feeding
+                audioTrack.play();
+
+                // decode start
+                final long TIMEOUT_US = 1000;
+                MediaCodec.BufferInfo info = new MediaCodec.BufferInfo();
+                boolean sawInputEOS = false;
+                boolean sawOutputEOS = false;
+                int noOutputCounter = 0;
+                int noOutputCounterLimit = 10;
+
+                boolean stop = false;
+                long presentationTimeUs = 0;
+
+                int sampleSize = 0;
+                SdPackage sdp = null;
+                long startMs = System.currentTimeMillis();
+                while (!sawOutputEOS && noOutputCounter < noOutputCounterLimit
+                        && !stop) {
+                    noOutputCounter++;
+                    // read a buffer before feeding it to the decoder
+                    if (!sawInputEOS) {
+                        int inputBufIndex = codec
+                                .dequeueInputBuffer(TIMEOUT_US);
+                        if (inputBufIndex >= 0) {
+                            ByteBuffer dstBuf = codecInputBuffers[inputBufIndex];
+                            try {
+
+                                if ((sdp = (SdPackage) ois.readObject()) != null) {
+
+                                    byte[] temp_bytearray = null;
+
+                                    sampleSize = sdp.getSampleSize();
+                                    temp_bytearray = new byte[sampleSize];
+                                    temp_bytearray = sdp.getSampleData();
+                                    // Log.i(TAG,
+                                    // Arrays.toString(temp_bytearray));
+                                    dstBuf.clear();
+                                    dstBuf.put(temp_bytearray);
+                                    presentationTimeUs = sdp.getPresentationTime();
+
+//                                    Log.i(TAG, sdp.toString());
+                                }
+                                else {
+                                    break;
+                                }
+
+                            } catch (IOException e) {
+                                // TODO Auto-generated catch block
+                                e.printStackTrace();
+                            } catch (ClassNotFoundException e) {
+                                // TODO Auto-generated catch block
+                                e.printStackTrace();
+                                break;
+                            }
+
+                            codec.queueInputBuffer(inputBufIndex, 0,
+                                    sampleSize, presentationTimeUs, 0);
+
+                            // Log.d(TAG, "client: queued to inputbuffer "
+                            // + inputBufIndex);
+                            // if (!sawInputEOS) //remote
+                            // extractor.advance(); //remote
+
+                        } else {
+                            Log.e(TAG, "client: inputBufIndex " + inputBufIndex);
+                        }
+                    } // !sawInputEOS
+
+                    // decode to PCM and push it to the AudioTrack player
+                    int res = codec.dequeueOutputBuffer(info, 1000);
+
+                    if (res >= 0) {
+                        if (info.size > 0)
+                            noOutputCounter = 0;
+
+                        int outputBufIndex = res;
+                        ByteBuffer buf = codecOutputBuffers[outputBufIndex];
+
+                        final byte[] chunk = new byte[info.size];
+                        buf.get(chunk);
+                        buf.clear();
+
+                        // sync
+                        // aSync = info.presentationTimeUs;
+                        // while(aSync - vSync >= 100){
+                        // try {
+                        // Thread.sleep(10);
+                        // } catch (InterruptedException e) {
+                        // // TODO Auto-generated catch block
+                        // e.printStackTrace();
+                        // }
+                        // }
+
+                        // while (info.presentationTimeUs / 1000 > System
+                        // .currentTimeMillis() - startMs) {
+                        // try {
+                        // Thread.sleep(10);
+                        // } catch (InterruptedException e) {
+                        // e.printStackTrace();
+                        // break;
+                        // }
+                        // }
+                        if (chunk.length > 0) {
+
+                            audioTrack.write(chunk, 0, chunk.length);
+
+                        }
+                        codec.releaseOutputBuffer(outputBufIndex, false);
+                        if ((info.flags & MediaCodec.BUFFER_FLAG_END_OF_STREAM) != 0) {
+                            Log.d(TAG, "saw output EOS.");
+                            sawOutputEOS = true;
+                        }
+                    } else if (res == MediaCodec.INFO_OUTPUT_BUFFERS_CHANGED) {
+                        Log.d(TAG,
+                                "oh! information of output buffer has been changed");
+                        codecOutputBuffers = codec.getOutputBuffers();
+                        Log.d(TAG, "output buffers have changed.");
+                    } else if (res == MediaCodec.INFO_OUTPUT_FORMAT_CHANGED) {
+                        Log.d(TAG, "oh! the output format changed!");
+                        MediaFormat oformat = codec.getOutputFormat();
+                        Log.d(TAG, "output format has changed to " + oformat);
+                    } else {
+                        Log.d(TAG, "dequeueOutputBuffer returned " + res);
+                    }
+
+                    // Log.d("TAG", String.valueOf(noOutputCounter));
+                }
+
+                Log.d(TAG, "stopping...");
+
+                if (codec != null) {
+                    codec.stop();
+                    codec.release();
+                    codec = null;
+                }
+                if (audioTrack != null) {
+                    audioTrack.flush();
+                    audioTrack.release();
+                    audioTrack = null;
+                }
+                // if(aServer != null){
+                // aServer.close();
+                // aServer = null;
+                // }
+                if (socket != null) {
+                    socket.close();
+                    socket = null;
+                }
+
+            } catch (UnknownHostException uhe) {
+                // TODO Auto-generated catch block
+                uhe.printStackTrace();
+            } catch (IOException ie) {
+                // TODO Auto-generated catch block
+                ie.printStackTrace();
+            } catch (ClassNotFoundException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+            return null;
+        }
+
+    }
+
+    private class mAudioPlayer extends Thread {
+
+        @Override
+        public void run() {
+            // TODO Auto-generated method stub
+
+            // variables of format
+            String mime = "";
+            int sampleRate = 0, channels = 0, bitrate = 0;
+            long duration = 0;
+            MediaFormat format = null;
+
+            InputStream in = null;
+            ObjectInputStream ois = null;
+            OutputStream out = null;
+            ObjectOutputStream oos = null;
+            Socket socket;
+            try {
+                while ((socket = new Socket(serverIP, vport + 1)).isConnected()) {
+                    break;
+                }
+
+                // ServerSocket aServer = new ServerSocket(aport);
+                // Socket socket = aServer.accept();
+
+                out = socket.getOutputStream();
+                oos = new ObjectOutputStream(out);
+                in = socket.getInputStream();
+                ois = new ObjectInputStream(in);
+
+                String test = ois.readUTF();
+                if (test.equalsIgnoreCase("hello")) {
+                    Log.d(TAG, "client and server is all clear");
+                }
+
+                // getting meta-information for format from server (from here)
+                SdPackage format_package = (SdPackage) ois.readObject();
+                mime = format_package.getMime();
+                sampleRate = format_package.getSampleRate();
+                channels = format_package.getChannels();
+                duration = format_package.getDuration();
+                bitrate = format_package.getBitrate();
+                format = MediaFormat.createAudioFormat(mime, sampleRate,
+                        channels);
+
+                format.setInteger(MediaFormat.KEY_AAC_PROFILE,
+                        MediaCodecInfo.CodecProfileLevel.AACObjectLC);
+                format.setByteBuffer("csd-0",
+                        ByteBuffer.wrap(format_package.get_csd0()));
+                format.setLong(MediaFormat.KEY_DURATION, duration);
+                format.setInteger(MediaFormat.KEY_BIT_RATE, bitrate);
+                // getting variables from server is finished
+
+                // checking if everything is okay
+                Log.d(TAG, "Audio Track info: mime:" + mime + " sampleRate:"
+                        + sampleRate + " channels:" + channels + " bitrate:"
+                        + bitrate + " duration:" + duration);
+                Log.d(TAG, "Audio Track: " + format.toString());
+                // codec setting
+                MediaCodec codec;
+                codec = MediaCodec.createDecoderByType(mime);
+                codec.configure(format, null, null, 0);
+                codec.start();
+
+                ByteBuffer[] codecInputBuffers = codec.getInputBuffers();
+                ByteBuffer[] codecOutputBuffers = codec.getOutputBuffers();
+
+                int channelConfiguration = 0;
+                if (channels == 1) {
+                    channelConfiguration = AudioFormat.CHANNEL_OUT_MONO;
+                } else {
+                    channelConfiguration = AudioFormat.CHANNEL_OUT_STEREO;
+                }
+
+                // audiotrack object
+                int minSize = AudioTrack.getMinBufferSize(sampleRate,
+                        channelConfiguration, AudioFormat.ENCODING_PCM_16BIT);
+                AudioTrack audioTrack;
+                audioTrack = new AudioTrack(AudioManager.STREAM_MUSIC,
+                        sampleRate, channelConfiguration,
+                        AudioFormat.ENCODING_PCM_16BIT, minSize,
+                        AudioTrack.MODE_STREAM);
+                // feeding
+                audioTrack.play();
+
+                // decode start
+                final long TIMEOUT_US = 10000;
+                MediaCodec.BufferInfo info = new MediaCodec.BufferInfo();
+                boolean sawInputEOS = false;
+                boolean sawOutputEOS = false;
+                int noOutputCounter = 0;
+                int noOutputCounterLimit = 10;
+
+                boolean stop = false;
+                long presentationTimeUs = 0;
+
+                int sampleSize = 0;
+                SdPackage sdp = null;
+                long startMs = System.currentTimeMillis();
+                while (!sawOutputEOS && noOutputCounter < noOutputCounterLimit
+                        && !stop) {
+                    noOutputCounter++;
+                    // read a buffer before feeding it to the decoder
+                    if (!sawInputEOS) {
+                        int inputBufIndex = codec
+                                .dequeueInputBuffer(TIMEOUT_US);
+                        if (inputBufIndex >= 0) {
+                            ByteBuffer dstBuf = codecInputBuffers[inputBufIndex];
+                            try {
+
+                                if ((sdp = (SdPackage) ois.readObject()) != null) {
+
+                                    byte[] temp_bytearray = null;
+
+                                    sampleSize = sdp.getSampleSize();
+                                    temp_bytearray = new byte[sampleSize];
+                                    temp_bytearray = sdp.getSampleData();
+                                    // Log.i(TAG,
+                                    // Arrays.toString(temp_bytearray));
+                                    dstBuf.clear();
+                                    dstBuf.put(temp_bytearray);
+                                    presentationTimeUs = sdp.getPresentationTime();
+
+                                    Log.i(TAG, sdp.toString());
+                                }
+                                else {
+                                    break;
+                                }
+
+                            } catch (IOException e) {
+                                // TODO Auto-generated catch block
+                                e.printStackTrace();
+                            } catch (ClassNotFoundException e) {
+                                // TODO Auto-generated catch block
+                                e.printStackTrace();
+                                break;
+                            }
+
+                            codec.queueInputBuffer(inputBufIndex, 0,
+                                    sampleSize, presentationTimeUs, 0);
+
+                            // Log.d(TAG, "client: queued to inputbuffer "
+                            // + inputBufIndex);
+                            // if (!sawInputEOS) //remote
+                            // extractor.advance(); //remote
+
+                        } else {
+                            Log.e(TAG, "client: inputBufIndex " + inputBufIndex);
+                        }
+                    } // !sawInputEOS
+
+                    // for (int i = 0; i < codecOutputBuffers.length; i++) {
+                    // Log.d(TAG, String.valueOf(codecOutputBuffers[i]
+                    // .remaining()));
+                    // }
+
+                    // decode to PCM and push it to the AudioTrack player
+                    int res = codec.dequeueOutputBuffer(info, 5000);
+
+                    if (res >= 0) {
+                        if (info.size > 0)
+                            noOutputCounter = 0;
+
+                        int outputBufIndex = res;
+                        ByteBuffer buf = codecOutputBuffers[outputBufIndex];
+
+                        final byte[] chunk = new byte[info.size];
+                        buf.get(chunk);
+                        buf.clear();
+
+                        // //sync
+                        // aSync = presentationTimeUs;
+                        // while(aSync - vSync > 0){
+                        // continue;
+                        // }
+                        while (info.presentationTimeUs / 1000 > System
+                                .currentTimeMillis() - startMs) {
+                            try {
+                                sleep(50);
+                            } catch (InterruptedException e) {
+                                e.printStackTrace();
+                                break;
+                            }
+                        }
+                        if (chunk.length > 0) {
+
+                            audioTrack.write(chunk, 0, chunk.length);
+
+                        }
+                        codec.releaseOutputBuffer(outputBufIndex, false);
+                        if ((info.flags & MediaCodec.BUFFER_FLAG_END_OF_STREAM) != 0) {
+                            Log.d(TAG, "saw output EOS.");
+                            sawOutputEOS = true;
+                        }
+                    } else if (res == MediaCodec.INFO_OUTPUT_BUFFERS_CHANGED) {
+                        Log.d(TAG,
+                                "oh! information of output buffer has been changed");
+                        codecOutputBuffers = codec.getOutputBuffers();
+                        Log.d(TAG, "output buffers have changed.");
+                    } else if (res == MediaCodec.INFO_OUTPUT_FORMAT_CHANGED) {
+                        Log.d(TAG, "oh! the output format changed!");
+                        MediaFormat oformat = codec.getOutputFormat();
+                        Log.d(TAG, "output format has changed to " + oformat);
+                    } else {
+                        Log.d(TAG, "dequeueOutputBuffer returned " + res);
+                    }
+
+                    // Log.d("TAG", String.valueOf(noOutputCounter));
+                }
+
+                Log.d(TAG, "stopping...");
+
+                if (codec != null) {
+                    codec.stop();
+                    codec.release();
+                    codec = null;
+                }
+                if (audioTrack != null) {
+                    audioTrack.flush();
+                    audioTrack.release();
+                    audioTrack = null;
+                }
+                // if(aServer != null){
+                // aServer.close();
+                // aServer = null;
+                // }
+                if (socket != null) {
+                    socket.close();
+                    socket = null;
+                }
+
+            } catch (UnknownHostException uhe) {
+                // TODO Auto-generated catch block
+                uhe.printStackTrace();
+            } catch (IOException ie) {
+                // TODO Auto-generated catch block
+                ie.printStackTrace();
+            } catch (ClassNotFoundException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+        }
+    }
+
+    private class mVideoPlayer extends Thread {
+        private MediaFormat format;
+        private MediaCodec mDecoder;
+        private Surface surface;
+
+        public mVideoPlayer(SurfaceHolder mHolder) {
+            // TODO Auto-generated constructor stub
+            surface = mHolder.getSurface();
+        }
+
+        @Override
+        public void run() {
+            Socket socket;
+            try {
+                System.setProperty("http.keepAlive", "false");
+                // ServerSocket ss = new ServerSocket(vport);
+                // ss.setReuseAddress(true);
+                while ((socket = new Socket(serverIP, vport)).isConnected()) {
+                    break;
+                }
+                socket.setTcpNoDelay(true);
+                // socket = new Socket(serverIP, vport);
+                while (true) {
+                    // Socket socket = ss.accept();
+                    Log.d(TAG, "Video Client is ready to go");
+                    InputStream is = socket.getInputStream();
+                    ObjectInputStream ois = new ObjectInputStream(is);
+
+                    // just a test
+                    String mime = ois.readUTF();
+                    int width, height;
+                    Log.d(TAG, "Server: " + mime + "ed"); // "Server: connected"
+                                                          // should be printed
+
+                    // get format data
+                    vData vdata = (vData) ois.readObject();
+                    mime = vdata.getMime();
+                    width = vdata.getWidth();
+                    height = vdata.getHeight();
+                    format = MediaFormat.createVideoFormat(mime, width, height);
+                    format.setByteBuffer("csd-0",
+                            ByteBuffer.wrap(vdata.get_csd0()));
+                    format.setByteBuffer("csd-1",
+                            ByteBuffer.wrap(vdata.get_csd1()));
+
+                    // hard coding for test
+                    // byte[] header_sps = { 0, 0, 0, 1, 0x67, 0x42, 0x0, 0x28,
+                    // 0xffffffe9, 0x1, 0x68, 0x7b, 0x20 };
+                    // byte[] header_pps = { 0, 0, 0, 1, 0x68, 0xffffffce, 0x1,
+                    // 0xe, 0x20 };
+                    // format.setByteBuffer("csd-0",
+                    // ByteBuffer.wrap(header_sps));
+                    // format.setByteBuffer("csd-1",
+                    // ByteBuffer.wrap(header_pps));
+                    // format.setInteger(MediaFormat.KEY_MAX_INPUT_SIZE, 47380);
+                    // format.setInteger(MediaFormat.KEY_DURATION, 5284377);
+                    Log.d(TAG, "server:  " + format.toString());
+
+                    // codec config and start
+                    mDecoder = MediaCodec.createDecoderByType(mime);
+                    mDecoder.configure(format, mHolder.getSurface(), null, 0);
+                    mDecoder.start();
+
+                    Log.d(TAG, "Video: server format setting done");
+
+                    // decoder start
+                    ByteBuffer[] inputBuffers = mDecoder.getInputBuffers();
+                    ByteBuffer[] outputBuffers = mDecoder.getOutputBuffers();
+                    BufferInfo info = new BufferInfo();
+                    boolean isEOS = false;
+                    long startMs = System.currentTimeMillis();
+
+                    while (!isEOS) {
+                        int inputIndex = mDecoder.dequeueInputBuffer(10000);
+                        if (inputIndex >= 0) {
+
+                            ByteBuffer buffer = inputBuffers[inputIndex];
+
+                            vdata = (vData) ois.readObject();
+                            int sampleSize = vdata.getSampleSize();
+                            buffer.clear();
+                            buffer.put(vdata.getSampleData());
+                            // int sampleSize = ois.readInt();
+                            byte[] tmp = null;
+                            if (sampleSize <= 0) {
+                                Log.d(TAG, "sampleSize is negative");
+                                continue;
+                            } else {
+                                tmp = new byte[sampleSize];
+                            }
+
+                            // Log.d(TAG, "got this much: " + tmp.length);
+
+                            long presentationTime = vdata.getPresentationTime();
+
+                            if (sampleSize < 0) {
+                                // We shouldn't stop the playback at this point,
+                                // just pass the EOS
+                                // flag to decoder, we will get it again from
+                                // the dequeueOutputBuffer
+                                Log.d("DecodeActivity",
+                                        "InputBuffer BUFFER_FLAG_END_OF_STREAM");
+                                mDecoder.queueInputBuffer(inputIndex, 0, 0, 0,
+                                        MediaCodec.BUFFER_FLAG_END_OF_STREAM);
+                                isEOS = true;
+                            }
+                            else {
+                                mDecoder.queueInputBuffer(inputIndex, 0,
+                                        sampleSize, presentationTime, 0);
+                                // mDecoder.queueInputBuffer(inputIndex, 0,
+                                // sampleSize, vdata.getPresentationTime(), 0);
+                                // mExtractor.advance();
+
+                                // Log.d(TAG, "got this much: " + tmp.length);
+                            }
+                        }
+
+                        int outIndex = mDecoder
+                                .dequeueOutputBuffer(info, 5000);
+                        switch (outIndex) {
+                            case MediaCodec.INFO_OUTPUT_BUFFERS_CHANGED:
+                                Log.d(TAG, "INFO_OUTPUT_BUFFERS_CHANGED");
+                                outputBuffers = mDecoder.getOutputBuffers();
+                                break;
+                            case MediaCodec.INFO_OUTPUT_FORMAT_CHANGED:
+                                Log.d(TAG,
+                                        "New format " + mDecoder.getOutputFormat());
+                                break;
+                            case MediaCodec.INFO_TRY_AGAIN_LATER:
+                                Log.d(TAG, "dequeueOutputBuffer timed out!");
+                                break;
+                            default:
+                                // ByteBuffer buffer = outputBuffers[outIndex];
+                                // Log.v(TAG,
+                                // "We can't use this buffer but render it due to the API limit, "
+                                // + buffer);
+
+                                // We use a very simple clock to keep the video
+                                // FPS,
+                                // or the video playback will be too fast
+                                while (info.presentationTimeUs / 1000 > System
+                                        .currentTimeMillis() - startMs) {
+                                    try {
+                                        sleep(50);
+                                    } catch (InterruptedException e) {
+                                        e.printStackTrace();
+                                        break;
+                                    }
+                                }
+
+                                mDecoder.releaseOutputBuffer(outIndex, true);
+
+                                break;
+                        }
+                        // All decoded frames have been rendered, we can stop
+                        // playing now
+                        if ((info.flags & MediaCodec.BUFFER_FLAG_END_OF_STREAM) != 0) {
+                            Log.d(TAG, "OutputBuffer BUFFER_FLAG_END_OF_STREAM");
+                            break;
+                        }
+                    }
+
+                    mDecoder.stop();
+                    mDecoder.release();
+                    socket.close();
+                }
+
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            } catch (ClassNotFoundException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+        }
+    }
+
+    public class FileTransferClient implements Runnable {
+        String imagePath = Environment.getExternalStorageDirectory() + "/Download/" + "aa.jpg";
+
+        @Override
+        public void run() {
+            // TODO Auto-generated method stub
+
+            try {
+                System.out.println("waiting for the client..");
+                Socket socket = new Socket(serverIP, 11111);
+                System.out.println("client has connected");
+                try {
+                    File f = new File(imagePath);
+                    
+                    FileOutputStream fos = new FileOutputStream(f);
+                    BufferedOutputStream bos = new BufferedOutputStream(fos);
+                    DataInputStream dis = new DataInputStream(socket.getInputStream());
+                    
+                    int len=0, size = 4096;
+                    byte[] data = new byte[size];
+                    while((len = dis.read(data)) != -1){
+                        bos.write(data, 0, len);
+                    }
+                    
+                    bos.flush();
+                    bos.close();
+                    fos.close();
+                    dis.close();
+                    
+                    Log.d(TAG, "ok transfer done");
+                } catch (Exception e) {
+                    e.printStackTrace();
+                }
+
+                socket.close();
+
+                Intent intent = new Intent();
+                intent.setAction(Intent.ACTION_VIEW);
+                // intent.setDataAndType(Uri.parse(Environment.getExternalStorageDirectory()
+                // + "/Download/aa.jpg"), "image/*");
+                intent.setDataAndType(
+                        Uri.parse("file://" + imagePath), "image/*");
+                startActivity(intent);
+
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            } finally {
+
+            }
+
+        }
+    }
+
+    @Override
+    protected void onCreate(Bundle savedInstanceState) {
+        super.onCreate(savedInstanceState);
+        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
+        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
+                WindowManager.LayoutParams.FLAG_FULLSCREEN);
+        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
+        // getWindow().getDecorView().setSystemUiVisibility(View.SYSTEM_UI_FLAG_HIDE_NAVIGATION);
+        setContentView(R.layout.activity_surface_giver);
+        System.setProperty("http.keepAlive", "false");
+
+        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN |
+                WindowManager.LayoutParams.FLAG_DISMISS_KEYGUARD |
+                WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED |
+                WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON,
+                WindowManager.LayoutParams.FLAG_FULLSCREEN |
+                        WindowManager.LayoutParams.FLAG_DISMISS_KEYGUARD |
+                        WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED |
+                        WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON);
+
+        Log.d("AAA", "ac");
+        acquireCpuWakeLock(this);
+
+        IRemoteService mService = IRemoteService.Stub
+                .asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+        try {
+            
+            serverIP = mService.getClientIPs().get(0);
+        } catch (RemoteException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+
+        vport = (Integer) getIntent().getExtra("dcslab", 44444);
+        Log.d(TAG, "after intent " + vport);
+        String mod = getIntent().getStringExtra("mode");
+        Log.d(TAG, mod);
+        if (mod.equalsIgnoreCase("video") || mod.equalsIgnoreCase("dummy")) {
+            surfaceView = new SurfaceView(this);
+            surfaceView.getHolder().addCallback(this);
+            setContentView(surfaceView);
+            Log.d(TAG, "the mode is video or dummy");
+        }
+
+        Bundle b = getIntent().getExtras();
+        mod = b.getString("mode");
+
+        Log.d(TAG, mod);
+        if (mod.equalsIgnoreCase("image")) {
+            int imageWidth = b.getInt("imageWidth");
+            int imageHeight = b.getInt("imageHeight");
+            String imageConfig = b.getString("imageConfig");
+            Bitmap image = Bitmap.createBitmap(imageWidth, imageHeight, Bitmap.Config.ARGB_8888);
+            byte[] imagePixel = b.getByteArray("imagePixel");
+            image.copyPixelsFromBuffer(ByteBuffer.wrap(imagePixel));
+            
+            imageView = new ImageView(this);
+            imageView.setImageBitmap(image);
+            setContentView(imageView);
+            View v = imageView;
+            v.setOnTouchListener(new View.OnTouchListener() {
+
+                @Override
+                public boolean onTouch(View v, MotionEvent event) {
+                    // TODO Auto-generated method stub
+                    if (event.getAction() == event.ACTION_DOWN) {
+
+                        Log.d(TAG, "yes yes you are");
+                        Thread t = new Thread(new FileTransferClient());
+                        t.start();
+                    }
+                    return true;
+                }
+            });
+        }
+    }
+
+    @Override
+    public boolean onCreateOptionsMenu(Menu menu) {
+        // Inflate the menu; this adds items to the action bar if it is present.
+        getMenuInflater().inflate(R.menu.surface_giver, menu);
+        return true;
+    }
+
+    @Override
+    public boolean onOptionsItemSelected(MenuItem item) {
+        // Handle action bar item clicks here. The action bar will
+        // automatically handle clicks on the Home/Up button, so long
+        // as you specify a parent activity in AndroidManifest.xml.
+        int id = item.getItemId();
+        if (id == R.id.action_settings) {
+            return true;
+        }
+        return super.onOptionsItemSelected(item);
+    }
+
+    @Override
+    public void surfaceCreated(SurfaceHolder holder) {
+        // TODO Auto-generated method stub
+        Log.d(TAG, "Surface created");
+    }
+
+    @Override
+    public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
+        // TODO Auto-generated method stub
+
+        Log.d(TAG, "Surface changed!");
+        mHolder = holder;
+
+        // mVideoPlayer vp = new mVideoPlayer(holder);
+        // vp.start();
+        String mod = getIntent().getStringExtra("mode");
+        if (mod.equalsIgnoreCase("video")) {
+            vport = getIntent().getIntExtra("dcslab", 44444);
+            new mVideoPlayerAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, 1);
+            new mAudioPlayerAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, 1);
+        }
+        else if (mod.equalsIgnoreCase("dummyApp")) {
+            ;
+        }
+        // mAudioPlayer ap = new mAudioPlayer();
+        // ap.start();
+    }
+
+    @Override
+    public void surfaceDestroyed(SurfaceHolder holder) {
+        // TODO Auto-generated method stub
+
+    }
+
+    private static PowerManager.WakeLock sCpuWakeLock;
+    private static KeyguardManager.KeyguardLock mKeyguardLock;
+    private static boolean isScreenLock;
+
+    static void acquireCpuWakeLock(Context context) {
+        Log.e("PushWakeLock", "Acquiring cpu wake lock");
+        Log.e("PushWakeLock", "wake sCpuWakeLock = " + sCpuWakeLock);
+
+        if (sCpuWakeLock != null) {
+            return;
+        }
+        PowerManager pm = (PowerManager) context.getSystemService(Context.POWER_SERVICE);
+        sCpuWakeLock = pm.newWakeLock(
+                PowerManager.SCREEN_BRIGHT_WAKE_LOCK |
+                        PowerManager.ACQUIRE_CAUSES_WAKEUP |
+                        PowerManager.ON_AFTER_RELEASE, "hello");
+
+        sCpuWakeLock.acquire();
+    }
+
+    static void releaseCpuLock() {
+        Log.e("PushWakeLock", "Releasing cpu wake lock");
+        Log.e("PushWakeLock", "relase sCpuWakeLock = " + sCpuWakeLock);
+
+        if (sCpuWakeLock != null) {
+            sCpuWakeLock.release();
+            sCpuWakeLock = null;
+        }
+    }
+
+}
